'''
Created on Feb 19, 2018

@author: ola
'''

import time
 
def index1(source,key):
    if key in source:
        return source.index(key)
    return -1

def index2(source,key):
    found = -1
    for dex in range(len(source)):
        if source[dex] == key:
            found = dex
            break       
    return found

def index3(source,key):
    dex = 0
    while dex < len(source) and source[dex] != key:
        dex += 1
    
    if dex == len(source):
        return -1
    return dex


def timer(size, findfunc):
    values = []
    for x in range(size):
        values.append(x)
    
    for dex in range(len(values)):
        current = values[dex]
        search = findfunc(values,current)
        if search != dex:
            print("error on",dex)
    
    for _ in range(size):
        search = findfunc(values,size**2)
        if search != -1:
            print("error on",size**2)

if __name__ == '__main__':
    funcs = [index1,index2,index3]
    size = 10000
    for fun in funcs:
        start = time.process_time()
        timer(size,fun)
        stop  = time.process_time()
        total_time = stop-start
        print("%s for %d = %1.3f" % (fun.__name__,size,total_time))